SystemOrganization addCategory: #UsedObjectsMoose!

!CompiledMethod methodsFor: '*UsedObjectsMoose' stamp: 'MarianoMartinezPeck 5/31/2012 16:27'!
propertyIsUsed
	self isUsed
			ifTrue: [ ^ 'Used method' ] 
			ifFalse: [ ^ 'Unused method'].
	! !

!Class methodsFor: '*UsedObjectsMoose' stamp: 'MarianoMartinezPeck 5/31/2012 15:28'!
propertyHasUsedInstances 
	self allInstancesDo: [:inst | inst isUsed ifTrue: [^ 'Class with some instances used' ]  ]. 
	^ 'Class with no instances used' ! !

!Class methodsFor: '*UsedObjectsMoose' stamp: 'MarianoMartinezPeck 5/31/2012 15:28'!
propertyInstancesAmount
	| usedInstanceCount unusedInstanceCount |
	usedInstanceCount := 0.
	unusedInstanceCount := 0.
	self isAbstractClass ifTrue: [ ^ 0. ].
	self allInstancesDo: [:inst | inst isUsed ifTrue: [ usedInstanceCount := usedInstanceCount + 1  ] ifFalse: [ unusedInstanceCount := unusedInstanceCount +1  ]  ]. 
	^ usedInstanceCount.
	
! !

!Class methodsFor: '*UsedObjectsMoose' stamp: 'MarianoMartinezPeck 5/31/2012 15:29'!
propertyInstancesStates
	| usedInst |
	usedInst := 0.
	self isAbstractClass ifTrue: [
		self isUsed
			ifTrue: [ ^ 'Abstract used class' ] 
			ifFalse: [ ^ 'Abstract unused class'].
		].
	self allInstancesDo: [:inst | inst isUsed ifTrue: [^  'Class with used instances'  ] ifFalse: [ ^ 'Class with instances']  ]. 
	^ 'Class without instances'.! !

!Class methodsFor: '*UsedObjectsMoose' stamp: 'MarianoMartinezPeck 5/31/2012 15:29'!
propertyInstancesStatesAndAmount
	| usedInstanceCount unusedInstanceCount |
	usedInstanceCount := 0.
	unusedInstanceCount := 0.
	self isAbstractClass ifTrue: [
		self isUsed
			ifTrue: [ ^ 'Abstract used class' ] 
			ifFalse: [ ^ 'Abstract unused class'].
		].
	self instanceCount = 0 ifTrue: [ ^ 'Class without instances'].
	self allInstancesDo: [:inst | inst isUsed ifTrue: [ usedInstanceCount := usedInstanceCount + 1  ] ifFalse: [ unusedInstanceCount := unusedInstanceCount +1  ]  ]. 
	(usedInstanceCount = 0) ifTrue: [ ^ 'Class with instances but unused']. 
	(usedInstanceCount between:  1 and: 10) ifTrue: [^ 'Class with used instances between 1 and 10'].
	(usedInstanceCount between:  11 and: 100) ifTrue: [^ 'Class with used instances between11 and 100'].
	(usedInstanceCount between:  101 and: 1000) ifTrue: [^ 'Class with used instances between 101 and 1000'].	
	(usedInstanceCount between:  1001 and: 10000) ifTrue: [^ 'Class with used instances between 1001 and 10000'].	
	(usedInstanceCount between:  10001 and: 100000) ifTrue: [^ 'Class with used instances between 10001 and 100000'].	
	(usedInstanceCount between:  100001 and: 1000000) ifTrue: [^ 'Class with used instances between 100001 and 1000000'].	
	  
	
	
! !

!Class methodsFor: '*UsedObjectsMoose' stamp: 'MarianoMartinezPeck 5/31/2012 15:29'!
propertyInstancesStatesAndMemory
	| usedInstanceMemory  |
	usedInstanceMemory := 0.
	self isAbstractClass ifTrue: [
		self isUsed
			ifTrue: [ ^ 'Abstract used class' ] 
			ifFalse: [ ^ 'Abstract not used class'].
		].
	self instanceCount = 0 ifTrue: [ ^ 'No instances'].
	self allInstancesDo: [:inst | inst isUsed ifTrue: [ usedInstanceMemory := usedInstanceMemory + inst sizeInMemory  ] ]. 
	(usedInstanceMemory = 0) ifTrue: [ ^ 'Has instances but not used']. 
	(usedInstanceMemory between:  1 and: 10) ifTrue: [^ 'Used instances memory between 1 and 10 bytes'].
	(usedInstanceMemory between:  11 and: 100) ifTrue: [^ 'Used instances memory between11 and 100 bytes'].
	(usedInstanceMemory between:  101 and: 1000) ifTrue: [^ 'Used instances memory between 101 and 1000 bytes'].	
	(usedInstanceMemory between:  1001 and: 10000) ifTrue: [^ 'Used instances memory between 1001 and 10000 bytes'].	
	(usedInstanceMemory between:  10001 and: 100000) ifTrue: [^ 'Used instances memory between 10001 and 100000 bytes'].	
	(usedInstanceMemory between:  100001 and: 1000000) ifTrue: [^ 'Used instances memory between 100001 and 1000000 bytes'].	
	(usedInstanceMemory between:  1000001 and: 10000000) ifTrue: [^ 'Used instances memory between 1000001 and 10000000 bytes'].	
	  
	
	
! !

DistributionMap subclass: #DistributionMapComparator
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'UsedObjectsMoose'!

!DistributionMapComparator class methodsFor: 'as yet unclassified' stamp: 'MarianoMartinezPeck 8/27/2010 11:43'!
onDM1: aDistributionMao DM2: anotherDistributionMap

	^ self new onDM1: aDistributionMao DM2: anotherDistributionMap! !

!DistributionMapComparator methodsFor: 'as yet unclassified' stamp: 'MarianoMartinezPeck 8/27/2010 14:07'!
onDM1: aDistributionMao DM2: anotherDistributionMap

	aDistributionMao elementsAndPropertyValue keysAndValuesDo: [:aKey :aValue | 
		(anotherDistributionMap elementsAndPropertyValue at: aKey) = aValue 
			ifTrue: [ self elementsAndPropertyValue at: aKey put: aValue ]
			ifFalse: [ self elementsAndPropertyValue at: aKey put: #Different ]
		 ].
	self orderColorMap.	
	self partsAndElements: aDistributionMao partsAndElements.
! !

DistributionMap subclass: #UsedObjectsDistributionMap
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'UsedObjectsMoose'!

!UsedObjectsDistributionMap class methodsFor: 'visualizations' stamp: 'MarianoMartinezPeck 5/31/2012 15:32'!
amuntUsedInstances

	"self amuntUsedInstances
	"
	^ (self 
		onContainers: (self listOfCorePackagesWithoutTests) 
		elements: #justClasses 
		properties: #propertyInstancesStatesAndAmount)
			render
			open.! !

!UsedObjectsDistributionMap class methodsFor: 'as yet unclassified' stamp: 'MarianoMartinezPeck 8/25/2010 12:07'!
example4

	"self example4
	Each container is a package in PharoCore that doesnt include the word Test in its name. The elements of a package are classes. The used property is if the class has used instances.  
	"
	^ (self onContainers: (self listOfCorePackagesNamesWithoutTests 
		collect: [ :each | (PackageInfo named: each) ]) elements: #classes properties: [:element | element propertyHasUsedInstances = true] )
			render
			open.! !

!UsedObjectsDistributionMap class methodsFor: 'as yet unclassified' stamp: 'MarianoMartinezPeck 8/27/2010 14:25'!
example6

	"self example6  
	"
	| dm1 dm2 |
	
	UnusedObjectDiscoverer current startDiscovery.
	Transcript show: 'Something'.
	UnusedObjectDiscoverer current stopDiscoveryAndGetStadistics.
	
	dm1 := (self onContainers: (self listOfCorePackagesNamesWithoutTests 
		collect: [ :each | (PackageInfo named: each) ]) elements: #classes properties: [:element | element propertyHasUsedInstances] ).
		
	UnusedObjectDiscoverer current startDiscovery.
	Object browse.
	SystemNavigation default browseAllImplementorsOf: #printOn:.
	SystemNavigation default allSendersOf: #printOn:.
	UnusedObjectDiscoverer current stopDiscoveryAndGetStadistics.
	
	dm2 := (self onContainers: (self listOfCorePackagesNamesWithoutTests 
		collect: [ :each | (PackageInfo named: each) ]) elements: #classes properties: [:element | element propertyHasUsedInstances] ).
	
	(DistributionMapComparator onDM1: dm1 DM2: dm2) render open ! !

!UsedObjectsDistributionMap class methodsFor: 'as yet unclassified' stamp: 'MarianoMartinezPeck 9/23/2010 11:05'!
example8

	"self example8
	"
	^ (LinearDistributionMap onContainers: (self listOfCorePackagesNamesWithoutTests 
		collect: [ :each | (PackageInfo named: each) ]) elements: #classes properties: [:element | element propertyInstancesAmount ] )
			render
			open.! !

!UsedObjectsDistributionMap class methodsFor: 'visualizations' stamp: 'MarianoMartinezPeck 5/31/2012 15:49'!
includedAbstractClasses

	"self includedAbstractClasses"
	^ ((self 
			onContainers: (self listOfCorePackagesWithoutTests) 
			elements: #justClasses 
			properties: #propertyInstancesStates)
		propertyColorMap: (Dictionary new
			at: 'Class with used instances' put: Color red; 
			at:'Class with instances' put: Color green; 
			at: 'Class without instances' put: Color blue; 
			at:'Abstract used class' put: Color black; 
			at:'Abstract unused class' put: Color gray; 
			yourself); 
		yourself)
	render
	open.
		
! !

!UsedObjectsDistributionMap class methodsFor: 'as yet unclassified' stamp: 'MarianoMartinezPeck 5/18/2010 12:48'!
lisOfCoreClasses
	"{String . Point } "
	"self listOfCorePackages collect: [:each | each classes]"
	^ (PackageInfo named: 'Kernel') classes! !

!UsedObjectsDistributionMap class methodsFor: 'as yet unclassified' stamp: 'MarianoMartinezPeck 5/18/2010 12:38'!
listOfCorePackages
	^ self listOfCorePackagesNames collect: [:each |  PackageInfo named: each ]! !

!UsedObjectsDistributionMap class methodsFor: 'as yet unclassified' stamp: 'MarianoMartinezPeck 8/23/2010 16:10'!
listOfCorePackagesNames
	"To recreate this list, you can take a PharoCore image and print:
	PackageInfo allPackages collect: [:each| each packageName] 
"

	^  #('MultilingualTests' 'Morphic' 'ToolBuilder-Kernel' 'PackageInfo' 'Polymorph-ToolBuilder' 'Network-Kernel' 'Network-Protocols' 'Compiler' 'System-Finalization' 'Settings-Graphics' 'Collections' 'Network-RemoteDirectory' 'Traits' 'Network-URI' 'Settings-Display' 'Collections-Abstract' 'Settings-Compiler' 'MonticelloMocks' 'ScriptLoader11' 'System-Digital Signatures' 'System-Localization' 'MenuRegistration' 'Polymorph-TaskbarIcons' 'Monticello' 'ToolBuilder-Morphic' 'MCDirtyPackage' 'Collections-Weak' 'Settings-Polymorph' 'Tests' 'HelpSystem-Core-Utilities' 'SUnit' 'Collections-Text' 'Compression' 'Morphic-MorphTreeWidget' 'HelpSystem-Core' 'ToolsTest' 'Gofer-Core' 'Gofer-Tests' 'Collections-Stack' 'FreeType' 'MonticelloConfigurations' 'Polymorph-Geometry' 'Collections-Support' 'SUnitGUI' 'HelpSystem-Core-Model' 'Tests-VM' 'System-Change Notification' 'System' 'Tests-ObjectsAsMethods' 'HostMenus' 'Network-MIME' 'Network-RFC822' 'VB-Regex' 'TrueType' 'DeprecatedPreferences' 'System-Clipboard' 'System-Settings' 'MorphicTests' 'System-Serial Port' 'NetworkTests' 'Collections-Unordered' 'System-Changes' 'System-Object Storage' 'Collections-Traits' 'System-Platforms' 'Tests-PrimCallController' 'Morphic-TrueType' 'Multilingual' 'Graphics' 'Collections-Strings' 'KernelTests' 'System-FileRegistry' 'Tests-Bugs' 'ToolBuilder-SUnit' 'Tests-Release' 'Morphic-Balloon' 'Settings-Network' 'System-Applications' 'Polymorph-Tools-Diff' 'Settings-Tools' 'ScriptLoader' 'ST80' 'FreeTypeSubPixelAntiAliasing' 'Settings-Kernel' 'Settings-System' 'CompilerTests' 'System-Tools' 'System-Hashing' 'System-Download' 'Collections-Streams' 'Tests-SystemChangeNotification' 'GraphicsTests' 'Polymorph-Widgets' 'Kernel' 'Tools' 'Settings-FreeType' 'FreeTypeTests' 'Settings-Monticello' 'HelpSystem-Tests' 'Polymorph-EventEnhancements' 'System-Support' 'MonticelloGUI' 'System-FilePackage' 'System-Object Events' 'Announcements' 'System-Text' 'Exceptions' 'Network-UUID' 'System-Pools' 'FixUnderscores' 'HelpSystem-Core-UI' 'GraphicsResources' 'Files' 'Gofer' 'Network-MailSending' 'Collections-Arrayed' 'CollectionsTests' 'Balloon' 'Network-Url' 'Collections-Sequenceable')! !

!UsedObjectsDistributionMap class methodsFor: 'as yet unclassified' stamp: 'MarianoMartinezPeck 8/23/2010 16:36'!
listOfCorePackagesNamesWithoutTests
	"To recreate this list, you can take a PharoCore image and print:
	PackageInfo allPackages collect: [:each| each packageName] 
"
	^ self listOfCorePackagesNames reject: [:each| each includesSubString: 'Test' ] ! !

!UsedObjectsDistributionMap class methodsFor: 'as yet unclassified' stamp: 'MarianoMartinezPeck 8/23/2010 16:34'!
listOfCorePackagesWithoutTests
	^ self listOfCorePackagesNamesWithoutTests collect: [:each |  PackageInfo named: each ]! !

!UsedObjectsDistributionMap class methodsFor: 'visualizations' stamp: 'MarianoMartinezPeck 11/3/2010 19:34'!
methodLevel

	"self methodLevel"
	^ ((self 
			onContainers: self lisOfCoreClasses  
			elements: #methods 
			properties: #propertyIsUsed ) 
		propertyColorMap: (Dictionary new 
			at: 'Used method' put: Color red; 
			at: 'Unused method' put: Color blue; 
			yourself); 
		yourself)
		render
		open
	
! !

!UsedObjectsDistributionMap class methodsFor: 'visualizations' stamp: 'MarianoMartinezPeck 5/31/2012 15:49'!
usedAndUnusedClasses

	"self usedAndUnusedClasses
	Each container is a package in PharoCore. The elements of a package are classes.
	The used property is if the class has used instances.  
	"	
	^ ((self 
			onContainers: (self listOfCorePackagesWithoutTests) 
			elements: #justClasses 
			properties: #propertyHasUsedInstances )
			"properties: [:element | element propertyHasUsedInstances] "
		propertyColorMap: (Dictionary new 
			at: 'Class with some instances used' put: Color red;
			at: 'Class with no instances used' put: Color blue; yourself); 
			yourself)
		render
		open.
				
! !

!UsedObjectsDistributionMap class methodsFor: 'visualizations' stamp: 'MarianoMartinezPeck 5/31/2012 15:49'!
usedInstancesMemory

	"self usedInstancesMemory
	"
	^ (self 
			onContainers: (self listOfCorePackagesWithoutTests) 
			elements: #justClasses 
			properties: #propertyInstancesStatesAndMemory)
		render
		open.! !

!UsedObjectsDistributionMap methodsFor: 'as yet unclassified' stamp: 'MarianoMartinezPeck 8/24/2010 11:21'!
exportAsPNG
	| view |
	view := MOViewRenderer new.
	self renderOn: view.
	view canvas exportAsPNG! !

!UsedObjectsDistributionMap methodsFor: 'as yet unclassified' stamp: 'MarianoMartinezPeck 8/26/2010 09:41'!
initialize

	super initialize.
	elementsAndPropertyValue := IdentityDictionary new.! !

!PackageInfo methodsFor: '*UsedObjectsMoose' stamp: 'MarianoMartinezPeck 5/31/2012 15:32'!
justClasses
	^((self systemCategories gather:
		[:cat |
		(SystemOrganization listAtCategoryNamed: cat)
			collect: [:className | Smalltalk at: className]])
				sorted: [:a :b | a className <= b className]) select: [:each | each isTrait not ]! !

!PackageInfo methodsFor: '*UsedObjectsMoose' stamp: 'MarianoMartinezPeck 8/24/2010 17:10'!
name
	^ self packageName ! !
